import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:foo_apple_pay/foo_apple_pay.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    PlatformViewController viewController;
    try {
      FooApplePay.setHostNameAndPath('SqHost', 'SqPath');

      Future<bool> supportsAppleWallet =
          FooApplePay.deviceSupportsAppleWallet();
      print('$supportsAppleWallet');

      List<dynamic> localPasses = await FooApplePay.getLocalPasses();
      print('$localPasses');

      List<dynamic> remotePasses = await FooApplePay.getRemotePasses();
      print('$remotePasses');

      Future<bool> canAddCard = FooApplePay.canAddCardWithId('1');
      print('$canAddCard');

      Future<bool> cardAlreadyAddedLocal =
          FooApplePay.cardAlreadyAddedToLocalWallet('1');
      print('$cardAlreadyAddedLocal');

      Future<bool> cardAlreadyAddedRemote =
          FooApplePay.cardAlreadyAddedToRemoteWallet('1');
      print('$cardAlreadyAddedRemote');

      FooApplePay.addCard('1', '2', '3', '4', viewController, '6');
      FooApplePay.addCard('1', '2', '3', '4', viewController, '6', '7', '8');

      platformVersion = 'Called all methods';
    } catch (e) {
      platformVersion = 'Failed due to $e';
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Text('Running on: $_platformVersion\n'),
        ),
      ),
    );
  }
}
